## cbmc 4.2

=== src/Makefile ===
DIRS = ansi-c big-int cbmc cpp goto-cc goto-instrument goto-programs floatbv \
       goto-symex langapi pointer-analysis solvers util linking xmllang

all: cbmc.dir goto-cc.dir goto-instrument.dir

###############################################################################

util.dir: big-int.dir

# everything depends on util
$(patsubst %, %.dir, $(filter-out big-int util, $(DIRS))): util.dir

.PHONY: languages
.PHONY: clean

languages: util.dir langapi.dir \
           cpp.dir ansi-c.dir xmllang.dir

goto-instrument.dir: languages goto-programs.dir pointer-analysis.dir \
                     goto-symex.dir linking.dir

cbmc.dir: languages solvers.dir goto-symex.dir \
          pointer-analysis.dir goto-programs.dir linking.dir

solvers.dir: floatbv.dir

goto-cc.dir: languages pointer-analysis.dir goto-programs.dir linking.dir

$(patsubst %, %.dir, $(DIRS)):
	## Entering $(basename $@)
	$(MAKE) $(MAKEARGS) -C $(basename $@)

clean: $(patsubst %, %_clean, $(DIRS))

$(patsubst %, %_clean, $(DIRS)):
	if [ -e $(patsubst %_clean, %, $@)/. ] ; then \
		$(MAKE) $(MAKEARGS) -C $(patsubst %_clean, %, $@) clean ; \
	fi

=== regression/cpp/Makefile ===
default: tests.log

test:
	@../test.pl -c goto-cc

tests.log: ../test.pl
	@../test.pl -c goto-cc

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.c" "$$dir/*.out"; \
		fi; \
	done;

=== src/ansi-c/Makefile ===
SRC = c_typecast.cpp y.tab.cpp lex.yy.cpp ansi_c_parser.cpp \
      expr2c.cpp ansi_c_language.cpp c_sizeof.cpp \
      c_types.cpp trans_unit.cpp ansi_c_typecheck.cpp \
      c_preprocess.cpp \
      c_typecheck_base.cpp c_typecheck_initializer.cpp \
      c_typecheck_typecast.cpp c_typecheck_code.cpp \
      c_typecheck_expr.cpp c_typecheck_type.cpp string_constant.cpp \
      c_qualifiers.cpp c_typecheck_argc_argv.cpp ansi_c_parse_tree.cpp \
      preprocessor_line.cpp ansi_c_convert.cpp ansi_c_convert_type.cpp \
      type2name.cpp cprover_library.cpp anonymous_member.cpp \
      printf_formatter.cpp internal_additions.cpp padding.cpp \
      ansi_c_declaration.cpp designator.cpp concatenate_strings.cpp \
      literals/parse_float.cpp literals/unescape_string.cpp \
      literals/convert_float_literal.cpp \
      literals/convert_character_literal.cpp \
      literals/convert_integer_literal.cpp \
      literals/convert_string_literal.cpp

INCLUDES= -I .. -I ../util

include ../config.inc
include ../common

CLEANFILES = ansi-c$(LIBEXT) \
  y.tab.h y.tab.cpp lex.yy.cpp y.tab.cpp.output y.output \
  library/converter$(EXEEXT) cprover_library.inc \
  file_converter$(EXEEXT) \
  gcc_builtin_headers_generic.inc gcc_builtin_headers_ia32.inc \
  arm_builtin_headers.inc cw_builtin_headers.inc \
  gcc_builtin_headers_arm.inc gcc_builtin_headers_alpha.inc \
  gcc_builtin_headers_mips.inc gcc_builtin_headers_power.inc

all: ansi-c$(LIBEXT)

###############################################################################

y.tab.cpp: parser.y
	$(YACC) $(YFLAGS) $$flags -pyyansi_c -d parser.y -o y.tab.cpp

y.tab.h: y.tab.cpp
	if [ -e y.tab.hpp ] ; then mv y.tab.hpp y.tab.h ; else \
        mv y.tab.cpp.h y.tab.h ; fi

lex.yy.cpp: scanner.l
	$(LEX) -Pyyansi_c -o$@ scanner.l

# extra dependencies
y.tab$(OBJEXT): y.tab.cpp y.tab.h
lex.yy$(OBJEXT): y.tab.cpp lex.yy.cpp y.tab.h
cprover_library$(OBJEXT): cprover_library.inc

###############################################################################

library/converter$(EXEEXT): library/converter.cpp
	$(LINKBIN)

file_converter$(EXEEXT): file_converter.cpp
	$(LINKBIN)

.PHONY: library_check

library_check:
	for f in library/*.c ; do \
		[ $$f = "library/windows.c" ] && [ "x$(EXEEXT)" = "x" ] && continue ; \
		[ $$f = "library/threads.c" ] && continue ; \
		$(CC) -S -Wall -pedantic -std=gnu99 -fno-builtin $$f -o __libcheck.s \
			-include library/cprover.h \
			-Wno-unused-label -Wno-implicit-function-declaration -Wno-uninitialized ; \
		ec=$$? ; \
		$(RM) __libcheck.s ; \
		[ $$ec -eq 0 ] || exit $$ec ; \
	done
	
cprover_library.inc: library/converter$(EXEEXT) library/*.c
	cat library/*.c | library/converter$(EXEEXT) > $@

gcc_builtin_headers_ia32.inc: gcc_builtin_headers_ia32.h file_converter$(EXEEXT)
	./file_converter$(EXEEXT) < gcc_builtin_headers_ia32.h > $@

gcc_builtin_headers_alpha.inc: gcc_builtin_headers_alpha.h file_converter$(EXEEXT)
	./file_converter$(EXEEXT) < gcc_builtin_headers_alpha.h > $@

gcc_builtin_headers_arm.inc: gcc_builtin_headers_arm.h file_converter$(EXEEXT)
	./file_converter$(EXEEXT) < gcc_builtin_headers_arm.h > $@

gcc_builtin_headers_mips.inc: gcc_builtin_headers_mips.h file_converter$(EXEEXT)
	./file_converter$(EXEEXT) < gcc_builtin_headers_mips.h > $@

gcc_builtin_headers_power.inc: gcc_builtin_headers_power.h file_converter$(EXEEXT)
	./file_converter$(EXEEXT) < gcc_builtin_headers_power.h > $@

gcc_builtin_headers_generic.inc: gcc_builtin_headers_generic.h file_converter$(EXEEXT)
	./file_converter$(EXEEXT) < gcc_builtin_headers_generic.h > $@

arm_builtin_headers.inc: arm_builtin_headers.h file_converter$(EXEEXT)
	./file_converter$(EXEEXT) < arm_builtin_headers.h > $@

cw_builtin_headers.inc: cw_builtin_headers.h file_converter$(EXEEXT)
	./file_converter$(EXEEXT) < cw_builtin_headers.h > $@

cprover_library.cpp: cprover_library.inc

internal_additions$(OBJEXT): gcc_builtin_headers_generic.inc
internal_additions$(OBJEXT): gcc_builtin_headers_ia32.inc
internal_additions$(OBJEXT): gcc_builtin_headers_alpha.inc
internal_additions$(OBJEXT): gcc_builtin_headers_arm.inc
internal_additions$(OBJEXT): gcc_builtin_headers_mips.inc
internal_additions$(OBJEXT): gcc_builtin_headers_power.inc
internal_additions$(OBJEXT): arm_builtin_headers.inc
internal_additions$(OBJEXT): cw_builtin_headers.inc

###############################################################################

ansi-c$(LIBEXT): $(OBJ) 
	$(LINKLIB)

=== src/cbmc/Makefile ===
SRC = main.cpp parseoptions.cpp bmc.cpp dimacs.cpp languages.cpp \
      bv_cbmc.cpp symex_bmc.cpp show_vcc.cpp cbmc_solvers.cpp \
      xml_interface.cpp cover.cpp \
      counterexample_beautification.cpp

OBJ += ../ansi-c/ansi-c$(LIBEXT) \
      ../linking/linking$(LIBEXT) \
      ../big-int/bigint$(OBJEXT) \
      ../goto-programs/goto-programs$(LIBEXT) \
      ../goto-symex/goto-symex$(LIBEXT) \
      ../pointer-analysis/pointer-analysis$(LIBEXT) \
      ../langapi/langapi$(LIBEXT) \
      ../xmllang/xmllang$(LIBEXT) \
      ../solvers/solvers$(LIBEXT) \
      ../util/util$(LIBEXT)

INCLUDES= -I .. -I ../util

LIBS =

include ../config.inc
include ../common

CLEANFILES = cbmc$(EXEEXT)

all: cbmc$(EXEEXT)

ifneq ($(wildcard ../bv_refinement/Makefile),)
  OBJ += ../bv_refinement/bv_refinement$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_BV_REFINEMENT
endif

ifneq ($(wildcard ../cpp/Makefile),)
  OBJ += ../cpp/cpp$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_CPP
endif

ifneq ($(wildcard ../java/Makefile),)
  OBJ += ../java/java$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_JAVA
endif

ifneq ($(wildcard ../specc/Makefile),)
  OBJ += ../specc/specc$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_SPECC
endif

ifneq ($(wildcard ../php/Makefile),)
  OBJ += ../php/php$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_PHP
endif

###############################################################################

cbmc$(EXEEXT): $(OBJ)
	$(LINKBIN)

.PHONY: cbmc-mac-signed

cbmc-mac-signed: cbmc$(EXEEXT)
	strip cbmc$(EXEEXT) ; codesign -v -s $(OSX_IDENTITY) cbmc$(EXEEXT)

=== src/cpp/Makefile ===
SRC = cpp_id.cpp cpp_language.cpp expr2cpp.cpp cpp_parser.cpp \
      lex.yy.cpp cpp_typecheck.cpp cpp_convert_type.cpp \
      cpp_typecheck_expr.cpp cpp_typecheck_code.cpp \
      cpp_typecheck_type.cpp parse.cpp cpp_parse_tree.cpp \
      cpp_token_buffer.cpp cpp_typecheck_fargs.cpp \
      cpp_typecheck_resolve.cpp cpp_util.cpp \
      cpp_typecheck_function.cpp cpp_typecheck_namespace.cpp \
      cpp_name.cpp cpp_is_pod.cpp cpp_scope.cpp \
      cpp_typecheck_find_constructor.cpp template_map.cpp \
      cpp_scopes.cpp cpp_declarator.cpp cpp_instantiate_template.cpp \
      internal_additions.cpp cpp_type2name.cpp \
      cpp_typecheck_linkage_spec.cpp \
      cpp_typecheck_template.cpp cpp_typecheck_function_bodies.cpp \
      cpp_typecheck_initializer.cpp cpp_typecheck_compound_type.cpp \
      cpp_constructor.cpp cpp_destructor.cpp \
      cpp_final.cpp cpp_typecheck_conversions.cpp\
      cpp_typecheck_declaration.cpp cpp_declarator_converter.cpp \
      cpp_declaration.cpp cpp_namespace_spec.cpp \
      cpp_typecheck_using.cpp cpp_exception_id.cpp \
      cpp_typecheck_enum_type.cpp cpp_typecheck_bases.cpp \
      cpp_typecheck_constructor.cpp cpp_typecheck_virtual_table.cpp

INCLUDES= -I .. -I ../util

include ../config.inc
include ../common

CLEANFILES = cpp$(LIBEXT) lex.yy.cpp y.tab.cpp.output

all: cpp$(LIBEXT)

###############################################################################

cpp$(LIBEXT): $(OBJ)
	$(LINKLIB)

lex.yy.cpp: scanner.l
	$(LEX) -Pyycpp -olex.yy.cpp scanner.l

lex.yy$(OBJEXT): lex.yy.cpp

=== src/goto-cc/Makefile ===
SRC = goto-cc.cpp goto_cc_mode.cpp gcc_mode.cpp \
      get_base_name.cpp \
      gcc_cmdline.cpp ms_cl_cmdline.cpp \
      compile.cpp armcc_cmdline.cpp run.cpp \
      languages.cpp goto_cc_cmdline.cpp \
      ms_cl_mode.cpp armcc_mode.cpp cw_mode.cpp

OBJ += ../big-int/bigint$(OBJEXT) \
      ../goto-programs/goto-programs$(LIBEXT) \
      ../pointer-analysis/pointer-analysis$(LIBEXT) \
      ../util/util$(LIBEXT) \
      ../linking/linking$(LIBEXT) \
      ../ansi-c/ansi-c$(LIBEXT) \
      ../xmllang/xmllang$(LIBEXT) \
      ../langapi/langapi$(LIBEXT)

INCLUDES= -I .. -I ../util

LIBS =

CLEANFILES = goto-cc$(EXEEXT)

include ../config.inc
include ../common

all: goto-cc$(EXEEXT)

ifneq ($(wildcard ../cpp/Makefile),)
  OBJ += ../cpp/cpp$(LIBEXT)
  CP_CXXFLAGS += -D HAVE_CPP
endif

###############################################################################

goto-cc$(EXEEXT): $(OBJ)
	$(LINKBIN)

.PHONY: goto-cc-mac-signed

goto-cc-mac-signed: goto-cc$(EXEEXT)
	codesign -v -s $(OSX_IDENTITY) goto-cc$(EXEEXT)

=== src/goto-instrument/Makefile ===
SRC = main.cpp parseoptions.cpp document_claims.cpp languages.cpp \
      uninitialized.cpp uninitialized_domain.cpp full_slicer.cpp \
      object_id.cpp show_locations.cpp points_to.cpp \
      alignment_checks.cpp race_check.cpp rw_set.cpp \
      weak_memory.cpp nondet_volatile.cpp interrupt.cpp \
      mmio.cpp stack_depth.cpp nondet_static.cpp \
      cfg_dominators.cpp natural_loops.cpp

OBJ += ../ansi-c/ansi-c$(LIBEXT) \
      ../linking/linking$(LIBEXT) \
      ../big-int/bigint$(OBJEXT) \
      ../goto-programs/goto-programs$(LIBEXT) \
      ../goto-symex/goto-symex$(LIBEXT) \
      ../pointer-analysis/pointer-analysis$(LIBEXT) \
      ../langapi/langapi$(LIBEXT) \
      ../util/util$(LIBEXT)

INCLUDES= -I .. -I ../util

LIBS =

CLEANFILES = goto-instrument$(EXEEXT)

include ../config.inc
include ../common

all: goto-instrument$(EXEEXT)

ifneq ($(wildcard ../cpp/Makefile),)
  OBJ += ../cpp/cpp$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_CPP
endif

ifneq ($(wildcard ../java/Makefile),)
  OBJ += ../java/java$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_JAVA
endif

ifneq ($(wildcard ../specc/Makefile),)
  OBJ += ../specc/specc$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_SPECC
endif

ifneq ($(wildcard ../php/Makefile),)
  OBJ += ../php/php$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_PHP
endif

###############################################################################

goto-instrument$(EXEEXT): $(OBJ)
	$(LINKBIN)

.PHONY: goto-instrument-mac-signed

goto-instrument-mac-signed: cbmc$(EXEEXT)
	codesign -v -s $(OSX_IDENTITY) goto-instrument$(EXEEXT)

=== src/goto-programs/Makefile ===
SRC = goto_convert.cpp goto_function.cpp goto_main.cpp goto_sideeffects.cpp \
      goto_program.cpp basic_blocks.cpp goto_check.cpp \
      remove_function_pointers.cpp goto_functions.cpp goto_inline.cpp \
      remove_skip.cpp goto_convert_functions.cpp string_instrumentation.cpp \
      builtin_functions.cpp show_claims.cpp destructor.cpp set_claims.cpp \
      reachability_slicer.cpp invariant_set.cpp invariant_propagation.cpp \
      read_goto_binary.cpp goto_asm.cpp elf_reader.cpp \
      invariant_set_domain.cpp static_analysis.cpp string_abstraction.cpp \
      goto_program_serialization.cpp goto_function_serialization.cpp \
      read_bin_goto_object.cpp goto_program_irep.cpp interpreter.cpp \
      interpreter_evaluate.cpp flow_insensitive_analysis.cpp \
      format_strings.cpp loop_numbers.cpp pointer_arithmetic.cpp \
      goto_program_template.cpp write_goto_binary.cpp remove_unreachable.cpp \
      remove_unused_functions.cpp dynamic_memory.cpp dump_c.cpp \
      wp.cpp goto_rw.cpp goto_clean_expr.cpp safety_checker.cpp \
      compute_called_functions.cpp link_to_library.cpp

INCLUDES= -I .. -I ../util

include ../config.inc
include ../common

LIBS = ../ansi-c/ansi-c$(LIBEXT)  ../util/util$(LIBEXT) \
	../big-int/bigint$(OBJEXT) goto-programs$(LIBEXT) \
	../pointer-analysis/pointer-analysis$(LIBEXT) \
	../langapi/langapi$(LIBEXT)

CLEANFILES = goto-programs$(LIBEXT) test_wp$(EXEEXT)

all: goto-programs$(LIBEXT)

###############################################################################

goto-programs$(LIBEXT): $(OBJ)
	$(LINKLIB)

test_wp$(EXEEXT): test_wp$(OBJEXT) goto-programs$(LIBEXT)
	$(LINKBIN)

=== src/goto-symex/Makefile ===
SRC = symex_target.cpp symex_target_equation.cpp basic_symex.cpp \
      symex_main.cpp goto_trace.cpp build_goto_trace.cpp \
      symex_function_call.cpp goto_symex_state.cpp symex_dereference.cpp \
      symex_goto.cpp builtin_functions.cpp slice.cpp symex_other.cpp \
      slice_by_trace.cpp xml_goto_trace.cpp symex_decl.cpp \
      precondition.cpp postcondition.cpp symex_clean_expr.cpp \
      symex_dereference_state.cpp vcd_goto_trace.cpp auto_objects.cpp \
      symex_catch.cpp symex_start_thread.cpp symex_assign.cpp

INCLUDES= -I .. -I ../util

include ../config.inc
include ../common

CLEANFILES = goto-symex$(LIBEXT)

all: goto-symex$(LIBEXT)

###############################################################################

goto-symex$(LIBEXT): $(OBJ)
	$(LINKLIB)

=== src/linking/Makefile ===
SRC = linking.cpp linking_type_eq.cpp zero_initializer.cpp \
      remove_internal_symbols.cpp entry_point.cpp

INCLUDES= -I .. -I ../util

include ../config.inc
include ../common

CLEANFILES = linking$(LIBEXT)

all: linking$(LIBEXT)

###############################################################################

linking$(LIBEXT): $(OBJ) 
	$(LINKLIB)

=== src/solvers/Makefile ===
include ../config.inc
include ../common

ifneq ($(CHAFF),)
  CHAFF_SRC=sat/satcheck_zchaff.cpp sat/satcheck_zcore.cpp
  CHAFF_INCLUDE=-I $(CHAFF)
  CHAFF_LIB=$(CHAFF)/libsat$(LIBEXT)
endif

ifneq ($(MINISAT),)
  MINISAT_SRC=sat/satcheck_minisat.cpp
  MINISAT_INCLUDE=-I $(MINISAT)
  MINISAT_LIB=$(MINISAT)/Solver$(OBJEXT) $(MINISAT)/Proof$(OBJEXT) $(MINISAT)/File$(OBJEXT)
  CP_CXXFLAGS += -DHAVE_MINISAT
endif

ifneq ($(MINISAT2),)
  MINISAT2_SRC=sat/satcheck_minisat2.cpp
  MINISAT2_INCLUDE=-I $(MINISAT2)
  MINISAT2_LIB=$(MINISAT2)/simp/SimpSolver$(OBJEXT) $(MINISAT2)/core/Solver$(OBJEXT)
  CP_CXXFLAGS += -DHAVE_MINISAT2 -D__STDC_FORMAT_MACROS -D__STDC_LIMIT_MACROS
  override CXXFLAGS := $(filter-out -pedantic, $(CXXFLAGS))
endif

ifneq ($(SMVSAT),)
  SMVSAT_SRC=sat/satcheck_smvsat.cpp
  SMVSAT_INCLUDE=-I $(SMVSAT)/include
  SMVSAT_LIB=$(SMVSAT)/lib/libsmvsat$(LIBEXT)
endif

ifneq ($(SQUOLEM2),)
  SQUOLEM2_SRC=qbf/qbf_squolem.cpp qbf/qbf_squolem_core.cpp
  SQUOLEM2_INCLUDE=-I $(SQUOLEM2)
  SQUOLEM2_LIB=-L $(SQUOLEM2) -lsquolem2
endif

ifneq ($(CUDD),)
  CUDD_SRC=qbf/qbf_bdd_core.cpp qbf/qbf_skizzo_core.cpp
  CUDD_INCLUDE=-I $(CUDD)/include
  CUDD_LIB=-L $(CUDD)/cudd -L $(CUDD)/util -L $(CUDD)/mtr \
           -L $(CUDD)/st -L $(CUDD)/obj -L $(CUDD)/dddmp \
           -L $(CUDD)/epd -lobj -lcudd -lmtr -lst -lutil -lepd -ldddmp
endif

ifneq ($(PRECOSAT),)
  PRECOSAT_SRC=sat/satcheck_precosat.cpp
  PRECOSAT_INCLUDE=-I $(PRECOSAT)
  PRECOSAT_LIB=$(PRECOSAT)/precosat$(OBJEXT)
  CP_CXXFLAGS += -DHAVE_PRECOSAT
endif

ifneq ($(PICOSAT),)
  PICOSAT_SRC=sat/satcheck_picosat.cpp
  PICOSAT_INCLUDE=-I $(PICOSAT)
  PICOSAT_LIB=$(PICOSAT)/libpicosat$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_PICOSAT
endif

ifneq ($(LINGELING),)
  LINGELING_SRC=sat/satcheck_lingeling.cpp
  LINGELING_INCLUDE=-I $(LINGELING)
  LINGELING_LIB=$(LINGELING)/liblgl$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_LINGELING
endif

SRC = $(CHAFF_SRC) $(BOOLEFORCE_SRC) $(MINISAT_SRC) $(MINISAT2_SRC) \
      $(SMVSAT_SRC) $(SQUOLEM2_SRC) $(CUDD_SRC) \
			$(PRECOSAT_SRC) $(PICOSAT_SRC) $(LINGELING_SRC) \
      sat/cnf.cpp sat/dimacs_cnf.cpp sat/cnf_clause_list.cpp \
      sat/pbs_dimacs_cnf.cpp sat/read_dimacs_cnf.cpp \
      sat/resolution_proof.cpp sat/satcheck.cpp \
      qbf/qdimacs_cnf.cpp qbf/qbf_quantor.cpp \
      qbf/qbf_skizzo.cpp qbf/qdimacs_core.cpp qbf/qbf_qube.cpp \
      qbf/qbf_qube_core.cpp \
      prop/prop.cpp prop/prop_conv.cpp prop/prop_conv_store.cpp \
      prop/aig_formula.cpp prop/cover_goals.cpp \
      prop/aig.cpp prop/aig_prop.cpp prop/minimize.cpp \
      cvc/cvc_prop.cpp cvc/cvc_conv.cpp cvc/cvc_dec.cpp \
      smt1/smt1_dec.cpp smt1/smt1_prop.cpp smt1/smt1_conv.cpp \
      smt2/smt2_dec.cpp smt2/smt2_prop.cpp smt2/smt2_conv.cpp \
      dplib/dplib_conv.cpp dplib/dplib_dec.cpp dplib/dplib_prop.cpp \
      flattening/equality.cpp flattening/arrays.cpp \
      flattening/functions.cpp flattening/bv_minimize.cpp \
      flattening/boolbv_width.cpp flattening/boolbv.cpp \
      flattening/boolbv_constraint_select_one.cpp \
      flattening/bv_pointers.cpp flattening/bv_utils.cpp \
      flattening/boolbv_abs.cpp flattening/boolbv_with.cpp \
      flattening/boolbv_typecast.cpp flattening/boolbv_index.cpp \
      flattening/boolbv_member.cpp flattening/boolbv_if.cpp \
      flattening/boolbv_byte_extract.cpp flattening/boolbv_add_sub.cpp \
      flattening/boolbv_mult.cpp flattening/boolbv_constant.cpp \
      flattening/boolbv_extractbit.cpp flattening/boolbv_bv_rel.cpp \
      flattening/boolbv_shift.cpp flattening/boolbv_case.cpp \
      flattening/boolbv_cond.cpp flattening/boolbv_concatenation.cpp \
      flattening/boolbv_div.cpp flattening/boolbv_mod.cpp \
      flattening/boolbv_extractbits.cpp flattening/boolbv_replication.cpp \
      flattening/boolbv_reduction.cpp flattening/boolbv_overflow.cpp \
      flattening/boolbv_get.cpp flattening/boolbv_bitwise.cpp \
      flattening/boolbv_equality.cpp flattening/boolbv_unary_minus.cpp \
      flattening/boolbv_ieee_float_rel.cpp flattening/pointer_logic.cpp \
      flattening/boolbv_quantifier.cpp flattening/boolbv_struct.cpp \
      flattening/boolbv_byte_update.cpp flattening/boolbv_array_of.cpp \
      flattening/boolbv_map.cpp flattening/boolbv_type.cpp \
      flattening/boolbv_array.cpp flattening/boolbv_vector.cpp \
      flattening/boolbv_complex.cpp \
      flattening/boolbv_union.cpp flattening/flatten_byte_operators.cpp

INCLUDES= -I .. -I ../util \
  $(CHAFF_INCLUDE) $(BOOLEFORCE_INCLUDE) $(MINISAT_INCLUDE) $(MINISAT2_INCLUDE) \
  $(SMVSAT_INCLUDE) $(SQUOLEM2_INC) $(CUDD_INCLUDE) \
	$(PRECOSAT_INCLUDE) $(PICOSAT_INCLUDE) $(LINGELING_INCLUDE)

CLEANFILES = solvers$(LIBEXT)

all: solvers$(LIBEXT)

ifneq ($(SQUOLEM2),)
  CP_CXXFLAGS += -DHAVE_QBF_CORE
else
ifneq ($(CUDD),)
  CP_CXXFLAGS += -DHAVE_QBF_CORE
endif
endif

ifneq ($(wildcard ../floatbv/Makefile),)
  CP_CXXFLAGS += -DHAVE_FLOATBV
  OBJ += ../floatbv/floatbv$(LIBEXT)
endif

# extra dependencies

-include $(SRC:.cpp=.d)

###############################################################################

solvers$(LIBEXT): $(OBJ) $(CHAFF_LIB) $(BOOLEFORCE_LIB) $(MINISAT_LIB) \
        $(MINISAT2_LIB) $(SMVSAT_LIB) $(SQUOLEM2_LIB) $(CUDD_LIB) \
				$(PRECOSAT_LIB) $(PICOSAT_LIB) $(LINGELING_LIB)
	$(LINKLIB)

=== src/util/Makefile ===
SRC = arith_tools.cpp base_type.cpp cmdline.cpp config.cpp context.cpp \
      expr.cpp expr_util.cpp i2string.cpp irep.cpp language.cpp \
      lispexpr.cpp lispirep.cpp location.cpp message.cpp language_file.cpp \
      mp_arith.cpp namespace.cpp parseoptions.cpp rename.cpp \
      replace_expr.cpp threeval.cpp typecheck.cpp graph.cpp \
      type.cpp cnf_simplify.cpp \
      bitvector.cpp parser.cpp map_util.cpp replace_symbol.cpp actuals.cpp \
      get_module.cpp string_hash.cpp string_container.cpp identifier.cpp \
      rational.cpp options.cpp c_misc.cpp simplify_expr.cpp dstring.cpp \
      find_symbols.cpp rational_tools.cpp ui_message.cpp simplify_utils.cpp \
      time_stopping.cpp symbol.cpp irep_hash_container.cpp cout_message.cpp \
      type_eq.cpp guard.cpp array_name.cpp gcd.cpp message_stream.cpp \
      substitute.cpp decision_procedure.cpp union_find.cpp pretty_names.cpp \
      xml.cpp xml_irep.cpp xml_expr.cpp std_types.cpp std_code.cpp \
      format_constant.cpp find_macros.cpp ref_expr_set.cpp std_expr.cpp \
      irep_serialization.cpp symbol_serialization.cpp fixedbv.cpp \
      ieee_float.cpp signal_catcher.cpp pointer_offset_size.cpp \
      bv_arithmetic.cpp tempdir.cpp tempfile.cpp timer.cpp unicode.cpp \
      irep_ids.cpp byte_operators.cpp string2int.cpp file_util.cpp

INCLUDES= -I .. -I .

LIBS = ../big-int/bigint$(OBJEXT)

include ../config.inc
include ../common

CLEANFILES = util$(LIBEXT) \
             irep_ids.h irep_ids.inc \
             ieee_float_test$(EXEEXT) ieee_float_test$(OBJEXT) ieee_float_test.d \
             irep_ids_convert$(EXEEXT) irep_ids_convert$(OBJEXT) irep_ids_convert.d

all: util$(LIBEXT) ieee_float_test$(EXEEXT)

ifneq ($(wildcard ../floatbv/Makefile),)
  CP_CXXFLAGS += -DHAVE_FLOATBV
endif

###############################################################################

irep_ids.h: irep_ids_convert$(EXEEXT) irep_ids.txt
	./irep_ids_convert$(EXEEXT) header < irep_ids.txt > $@

irep_ids.inc: irep_ids_convert$(EXEEXT) irep_ids.txt
	./irep_ids_convert$(EXEEXT) table < irep_ids.txt > $@

irep_ids.cpp: irep_ids.inc irep_ids.h

irep_ids_convert$(EXEEXT): irep_ids_convert$(OBJEXT)
	$(LINKBIN)

# Most of the others will need irep_ids.h,
# which we first need to generate.
$(OBJ): irep_ids.h

util$(LIBEXT): $(OBJ)
	$(LINKLIB)

ieee_float_test$(OBJEXT): irep_ids.h  

ieee_float_test$(EXEEXT): ieee_float_test$(OBJEXT) util$(LIBEXT)
	$(LINKBIN)

=== debian/changelog ===
cbmc (4.2-6ubuntu2) raring; urgency=low

  * Fix preprocessing on armhf by passing through the __ARM_PCS_VFP define.

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 07 Nov 2012 21:15:17 -0700

cbmc (4.2-6ubuntu1) raring; urgency=low

  * Don't fail on unused-result warnings.

 -- Ilya Barygin <randomaction@ubuntu.com>  Mon, 05 Nov 2012 16:13:36 +0400

cbmc (4.2-6) unstable; urgency=low

  * s390x hack, will be fixed properly in next upstream release

 -- Michael Tautschnig <mt@debian.org>  Thu, 20 Sep 2012 16:14:23 +0100

cbmc (4.2-5) unstable; urgency=low

  * Fix preprocessing on architectures with unsigned char
  * Proper word size define for mips
  * Added regression test to check for missing builtins

 -- Michael Tautschnig <mt@debian.org>  Thu, 20 Sep 2012 10:27:43 +0100

cbmc (4.2-4) unstable; urgency=low

  * Fix missing includes on freebsd kernels, once more
  * Fix test suite for non-x86 architecture specifics

 -- Michael Tautschnig <mt@debian.org>  Wed, 19 Sep 2012 17:47:42 +0100

cbmc (4.2-3) unstable; urgency=low

  * Fix missing includes on freebsd kernels
  * Fixed test output helper

 -- Michael Tautschnig <mt@debian.org>  Wed, 19 Sep 2012 16:57:50 +0100

cbmc (4.2-2) unstable; urgency=low

  * Updated Standards version to 3.9.4 (no changes required)
  * Include upstream man page
  * Updated debian/copyright to final syntax
  * Fix missing includes on hurd and freebsd kernels
  * Print test output of failed tests

 -- Michael Tautschnig <mt@debian.org>  Wed, 19 Sep 2012 12:02:56 +0100

cbmc (4.2-1) unstable; urgency=low

  * New upstream release (includes GCC 4.7 fixes of previous NMUs)
  * Use DEB_CXXFLAGS_MAINT_APPEND to comply with dpkg-buildflags
  * Run test suite after build

 -- Michael Tautschnig <mt@debian.org>  Wed, 19 Sep 2012 10:29:19 +0100

cbmc (4.1-1.2) unstable; urgency=low

  * Non-maintainer upload.
  * Update fix-FTBFS-with-gcc-4.7.patch patch.
    Fix FTBFS with gcc 4.7 on kfreebsd and hurd.
    Thanks to Steven Chamberlain <steven@pyro.eu.org> for the patch.
    (Closes: #673579)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 20 May 2012 07:55:28 +0200

cbmc (4.1-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Add fix-FTBFS-with-gcc-4.7.patch patch.
    Fix FTBFS with gcc 4.7. Fix missing <unistd.h> includes and add 'this->'
    where needed.
    Thanks to Cyril Brulebois <kibi@debian.org> for the patch. (Closes: #667131)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 13 May 2012 14:25:21 +0200

=== debian/control ===
Source: cbmc
Section: science
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Michael Tautschnig <mt@debian.org>
Build-Depends: debhelper (>= 9), minisat (>= 1:2.2.1-2), zlib1g-dev, flex, bison
Standards-Version: 3.9.4
Homepage: http://www.cprover.org/cbmc/

Package: cbmc
Architecture: any
Depends: gcc, ${shlibs:Depends}, ${misc:Depends}
Description: bounded model checker for C and C++ programs
 CBMC generates traces that demonstrate how an assertion can be violated, or
 proves that the assertion cannot be violated within a given number of loop
 iterations.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_CXXFLAGS_MAINT_APPEND := -Wall -O2 -g -Werror -Wno-long-long -Wno-sign-compare -Wno-parentheses -Wno-strict-aliasing -Wno-unused-result -pedantic

%:
	dh $@ --parallel

override_dh_auto_test:
	cd regression/ansi-c ; \
		if ! ../test.pl -c ../../../src/goto-cc/goto-cc ; then \
		  ../../debian/failed-tests-printer.pl ; \
			exit 1 ; \
		fi
	cd regression/cpp ; \
		if ! ../test.pl -c ../../../src/goto-cc/goto-cc ; then \
		  ../../debian/failed-tests-printer.pl ; \
			exit 1 ; \
		fi
	cd regression/cbmc ; \
		if ! ../test.pl -c ../../../src/cbmc/cbmc ; then \
		  ../../debian/failed-tests-printer.pl ; \
			exit 1 ; \
		fi

## cbmc 4.5

=== regression/Makefile ===
DIRS = ansi-c cbmc cpp 

test:
	$(foreach var,$(DIRS), make -C $(var) test;)

=== src/Makefile ===
DIRS = ansi-c big-int cbmc cpp goto-cc goto-instrument goto-programs \
       goto-symex langapi pointer-analysis solvers util linking xmllang \
       assembler analyses java_bytecode

all: cbmc.dir goto-cc.dir goto-instrument.dir

###############################################################################

util.dir: big-int.dir

# everything depends on util
$(patsubst %, %.dir, $(filter-out big-int util, $(DIRS))): util.dir

.PHONY: languages
.PHONY: clean

languages: util.dir langapi.dir \
           cpp.dir ansi-c.dir xmllang.dir assembler.dir java_bytecode.dir

goto-instrument.dir: languages goto-programs.dir pointer-analysis.dir \
                     goto-symex.dir linking.dir analyses.dir solvers.dir

cbmc.dir: languages solvers.dir goto-symex.dir analyses.dir \
          pointer-analysis.dir goto-programs.dir linking.dir

goto-cc.dir: languages pointer-analysis.dir goto-programs.dir linking.dir

# building for a particular directory

$(patsubst %, %.dir, $(DIRS)):
	## Entering $(basename $@)
	$(MAKE) $(MAKEARGS) -C $(basename $@)

# generate source files

$(patsubst %, %_generated_files, $(DIRS)):
	$(MAKE) $(MAKEARGS) -C $(patsubst %_generated_files, %, $@) generated_files
	
generated_files: $(patsubst %, %_generated_files, $(DIRS))

# cleaning

clean: $(patsubst %, %_clean, $(DIRS))

$(patsubst %, %_clean, $(DIRS)):
	$(MAKE) $(MAKEARGS) -C $(patsubst %_clean, %, $@) clean ; \

# minisat 2 download, for your convenience

minisat2-download:
	@echo "Downloading Minisat 2.2.0"
	@lwp-download http://minisat.se/downloads/minisat-2.2.0.tar.gz
	@tar xfz minisat-2.2.0.tar.gz
	@rm -Rf ../minisat-2.2.0
	@mv minisat ../minisat-2.2.0
	@(cd ../minisat-2.2.0; patch -p1 < ../scripts/minisat-2.2.0-patch)
	@rm minisat-2.2.0.tar.gz

=== regression/cbmc-from-CVS/Makefile ===
default: tests.log

test:
	@../test.pl -c cbmc

tests.log: ../test.pl
	@../test.pl -c cbmc

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.c" "$$dir/*.out"; \
		fi; \
	done;

=== regression/cpp/Makefile ===
default: tests.log

test:
	@../test.pl -c ../../../src/goto-cc/goto-cc

tests.log: ../test.pl
	@../test.pl -c ../../../src/goto-cc/goto-cc

show:
	@for dir in *; do \
		if [ -d "$$dir" ]; then \
			vim -o "$$dir/*.c" "$$dir/*.out"; \
		fi; \
	done;

=== src/analyses/Makefile ===
SRC = natural_loops.cpp is_threaded.cpp dirty.cpp interval_analysis.cpp \
      invariant_set.cpp invariant_set_domain.cpp invariant_propagation.cpp \
      static_analysis.cpp uninitialized_domain.cpp local_may_alias.cpp \
      locals.cpp goto_check.cpp call_graph.cpp interval_domain.cpp \
      reaching_definitions.cpp

INCLUDES= -I ..

include ../config.inc
include ../common

CLEANFILES = analyses$(LIBEXT)

all: analyses$(LIBEXT)

###############################################################################

analyses$(LIBEXT): $(OBJ) 
	$(LINKLIB)

=== src/ansi-c/Makefile ===
SRC = c_typecast.cpp ansi_c_y.tab.cpp ansi_c_lex.yy.cpp ansi_c_parser.cpp \
      expr2c.cpp ansi_c_language.cpp c_sizeof.cpp \
      c_types.cpp trans_unit.cpp ansi_c_typecheck.cpp \
      c_preprocess.cpp \
      c_typecheck_base.cpp c_typecheck_initializer.cpp \
      c_typecheck_typecast.cpp c_typecheck_code.cpp \
      c_typecheck_expr.cpp c_typecheck_type.cpp string_constant.cpp \
      c_qualifiers.cpp c_typecheck_argc_argv.cpp ansi_c_parse_tree.cpp \
      preprocessor_line.cpp ansi_c_convert.cpp ansi_c_convert_type.cpp \
      type2name.cpp cprover_library.cpp anonymous_member.cpp \
      printf_formatter.cpp ansi_c_internal_additions.cpp padding.cpp \
      ansi_c_declaration.cpp designator.cpp \
      literals/parse_float.cpp literals/unescape_string.cpp \
      literals/convert_float_literal.cpp \
      literals/convert_character_literal.cpp \
      literals/convert_integer_literal.cpp \
      literals/convert_string_literal.cpp

INCLUDES= -I ..

include ../config.inc
include ../common

CLEANFILES = ansi-c$(LIBEXT) \
  ansi_c_y.tab.h ansi_c_y.tab.cpp ansi_c_lex.yy.cpp ansi_c_y.tab.cpp.output \
  ansi_c_y.output \
  library/converter$(EXEEXT) cprover_library.inc \
  file_converter$(EXEEXT) library_check \
  gcc_builtin_headers_generic.inc gcc_builtin_headers_ia32.inc \
  arm_builtin_headers.inc cw_builtin_headers.inc \
  gcc_builtin_headers_arm.inc gcc_builtin_headers_alpha.inc \
  gcc_builtin_headers_mips.inc gcc_builtin_headers_power.inc

all: ansi-c$(LIBEXT)

###############################################################################

ansi_c_y.tab.cpp: parser.y
	$(YACC) $(YFLAGS) $$flags -pyyansi_c -d parser.y -o $@

ansi_c_y.tab.h: ansi_c_y.tab.cpp
	if [ -e ansi_c_y.tab.hpp ] ; then mv ansi_c_y.tab.hpp ansi_c_y.tab.h ; else \
        mv ansi_c_y.tab.cpp.h ansi_c_y.tab.h ; fi

ansi_c_lex.yy.cpp: scanner.l
	$(LEX) -Pyyansi_c -o$@ scanner.l

# extra dependencies
ansi_c_y.tab$(OBJEXT): ansi_c_y.tab.cpp ansi_c_y.tab.h
ansi_c_lex.yy$(OBJEXT): ansi_c_y.tab.cpp ansi_c_lex.yy.cpp ansi_c_y.tab.h
cprover_library$(OBJEXT): cprover_library.inc

###############################################################################

library/converter$(EXEEXT): library/converter.cpp
	$(LINKNATIVE)

file_converter$(EXEEXT): file_converter.cpp
	$(LINKNATIVE)

ifeq ($(BUILD_ENV),MinGW)
  platform_unavail = library/err.c library/threads.c
else
  platform_unavail = library/threads.c
endif
library_check: library/*.c
	for f in $(filter-out $(platform_unavail), $^) ; do \
		$(CC) -S -Wall -Werror -pedantic -Wextra -std=gnu99 $$f -o __libcheck.s \
			-include library/cprover.h -D__CPROVER_bool=_Bool -fno-builtin \
			-D_Thread_local=volatile -DLIBRARY_CHECK \
			-Wno-unused-label -Wno-uninitialized ; \
		ec=$$? ; \
		$(RM) __libcheck.s ; \
		[ $$ec -eq 0 ] || exit $$ec ; \
	done
	touch $@
	
cprover_library.inc: library/converter$(EXEEXT) library/*.c
	cat library/*.c | library/converter$(EXEEXT) > $@

gcc_builtin_headers_ia32.inc: gcc_builtin_headers_ia32.h file_converter$(EXEEXT)
	./file_converter$(EXEEXT) < gcc_builtin_headers_ia32.h > $@

gcc_builtin_headers_alpha.inc: gcc_builtin_headers_alpha.h file_converter$(EXEEXT)
	./file_converter$(EXEEXT) < gcc_builtin_headers_alpha.h > $@

gcc_builtin_headers_arm.inc: gcc_builtin_headers_arm.h file_converter$(EXEEXT)
	./file_converter$(EXEEXT) < gcc_builtin_headers_arm.h > $@

gcc_builtin_headers_mips.inc: gcc_builtin_headers_mips.h file_converter$(EXEEXT)
	./file_converter$(EXEEXT) < gcc_builtin_headers_mips.h > $@

gcc_builtin_headers_power.inc: gcc_builtin_headers_power.h file_converter$(EXEEXT)
	./file_converter$(EXEEXT) < gcc_builtin_headers_power.h > $@

gcc_builtin_headers_generic.inc: gcc_builtin_headers_generic.h file_converter$(EXEEXT)
	./file_converter$(EXEEXT) < gcc_builtin_headers_generic.h > $@

arm_builtin_headers.inc: arm_builtin_headers.h file_converter$(EXEEXT)
	./file_converter$(EXEEXT) < arm_builtin_headers.h > $@

cw_builtin_headers.inc: cw_builtin_headers.h file_converter$(EXEEXT)
	./file_converter$(EXEEXT) < cw_builtin_headers.h > $@

cprover_library.cpp: cprover_library.inc

ansi_c_internal_additions$(OBJEXT): gcc_builtin_headers_generic.inc
ansi_c_internal_additions$(OBJEXT): gcc_builtin_headers_ia32.inc
ansi_c_internal_additions$(OBJEXT): gcc_builtin_headers_alpha.inc
ansi_c_internal_additions$(OBJEXT): gcc_builtin_headers_arm.inc
ansi_c_internal_additions$(OBJEXT): gcc_builtin_headers_mips.inc
ansi_c_internal_additions$(OBJEXT): gcc_builtin_headers_power.inc
ansi_c_internal_additions$(OBJEXT): arm_builtin_headers.inc
ansi_c_internal_additions$(OBJEXT): cw_builtin_headers.inc

generated_files: cprover_library.inc gcc_builtin_headers_generic.inc \
	gcc_builtin_headers_ia32.inc gcc_builtin_headers_alpha.inc \
	gcc_builtin_headers_arm.inc gcc_builtin_headers_mips.inc \
	gcc_builtin_headers_power.inc arm_builtin_headers.inc \
	cw_builtin_headers.inc ansi_c_y.tab.cpp ansi_c_lex.yy.cpp \
	ansi_c_y.tab.h

###############################################################################

ansi-c$(LIBEXT): $(OBJ) 
	$(LINKLIB)

=== src/cbmc/Makefile ===
--- 
+++ 
@@ -1,20 +1,26 @@
-SRC = main.cpp parseoptions.cpp bmc.cpp dimacs.cpp languages.cpp \
+SRC = cbmc_main.cpp cbmc_parseoptions.cpp bmc.cpp dimacs.cpp \
+      cbmc_languages.cpp counterexample_beautification.cpp \
       bv_cbmc.cpp symex_bmc.cpp show_vcc.cpp cbmc_solvers.cpp \
-      xml_interface.cpp cover.cpp \
-      counterexample_beautification.cpp
+      xml_interface.cpp cover.cpp all_claims.cpp      
 
 OBJ += ../ansi-c/ansi-c$(LIBEXT) \
       ../linking/linking$(LIBEXT) \
-      ../big-int/bigint$(OBJEXT) \
+      ../big-int/big-int$(LIBEXT) \
       ../goto-programs/goto-programs$(LIBEXT) \
       ../goto-symex/goto-symex$(LIBEXT) \
-      ../pointer-analysis/pointer-analysis$(LIBEXT) \
+      ../pointer-analysis/value_set$(OBJEXT) \
+      ../pointer-analysis/dereference$(OBJEXT) \
+      ../pointer-analysis/add_failed_symbols$(OBJEXT) \
+      ../pointer-analysis/rewrite_index$(OBJEXT) \
+      ../pointer-analysis/goto_program_dereference$(OBJEXT) \
+      ../analyses/analyses$(LIBEXT) \
       ../langapi/langapi$(LIBEXT) \
       ../xmllang/xmllang$(LIBEXT) \
+      ../assembler/assembler$(LIBEXT) \
       ../solvers/solvers$(LIBEXT) \
       ../util/util$(LIBEXT)
 
-INCLUDES= -I .. -I ../util
+INCLUDES= -I ..
 
 LIBS =
 
@@ -35,9 +41,9 @@
   CP_CXXFLAGS += -DHAVE_CPP
 endif
 
-ifneq ($(wildcard ../java/Makefile),)
-  OBJ += ../java/java$(LIBEXT)
-  CP_CXXFLAGS += -DHAVE_JAVA
+ifneq ($(wildcard ../java_bytecode/Makefile),)
+  OBJ += ../java_bytecode/java_bytecode$(LIBEXT)
+  CP_CXXFLAGS += -DHAVE_JAVA_BYTECODE
 endif
 
 ifneq ($(wildcard ../specc/Makefile),)

=== src/cpp/Makefile ===
SRC = cpp_id.cpp cpp_language.cpp expr2cpp.cpp cpp_parser.cpp \
      cpp_lex.yy.cpp cpp_typecheck.cpp cpp_convert_type.cpp \
      cpp_typecheck_expr.cpp cpp_typecheck_code.cpp \
      cpp_typecheck_type.cpp parse.cpp cpp_parse_tree.cpp \
      cpp_token_buffer.cpp cpp_typecheck_fargs.cpp \
      cpp_typecheck_resolve.cpp cpp_util.cpp cpp_enum_type.cpp \
      cpp_typecheck_function.cpp cpp_typecheck_namespace.cpp \
      cpp_name.cpp cpp_is_pod.cpp cpp_scope.cpp \
      cpp_typecheck_find_constructor.cpp template_map.cpp \
      cpp_scopes.cpp cpp_declarator.cpp cpp_instantiate_template.cpp \
      cpp_internal_additions.cpp cpp_type2name.cpp \
      cpp_typecheck_linkage_spec.cpp \
      cpp_typecheck_template.cpp cpp_typecheck_function_bodies.cpp \
      cpp_typecheck_initializer.cpp cpp_typecheck_compound_type.cpp \
      cpp_constructor.cpp cpp_destructor.cpp \
      cpp_typecheck_conversions.cpp\
      cpp_typecheck_declaration.cpp cpp_declarator_converter.cpp \
      cpp_declaration.cpp cpp_namespace_spec.cpp \
      cpp_typecheck_using.cpp cpp_exception_id.cpp \
      cpp_typecheck_enum_type.cpp cpp_typecheck_bases.cpp \
      cpp_typecheck_constructor.cpp cpp_typecheck_virtual_table.cpp \
      cpp_typecheck_static_assert.cpp

INCLUDES= -I ..

include ../config.inc
include ../common

CLEANFILES = cpp$(LIBEXT) cpp_lex.yy.cpp cpp_y.tab.cpp.output

all: cpp$(LIBEXT)

###############################################################################

cpp$(LIBEXT): $(OBJ)
	$(LINKLIB)

cpp_lex.yy.cpp: scanner.l
	$(LEX) -Pyycpp -o$@ scanner.l

generated_files: cpp_lex.yy.cpp

cpp_lex.yy$(OBJEXT): cpp_lex.yy.cpp

=== src/goto-cc/Makefile ===
--- 
+++ 
@@ -1,20 +1,20 @@
-SRC = goto-cc.cpp goto_cc_mode.cpp gcc_mode.cpp \
+SRC = goto_cc_main.cpp goto_cc_mode.cpp gcc_mode.cpp \
       get_base_name.cpp \
-      gcc_cmdline.cpp ms_cl_cmdline.cpp \
+      gcc_cmdline.cpp ms_cl_cmdline.cpp ld_cmdline.cpp \
       compile.cpp armcc_cmdline.cpp run.cpp \
-      languages.cpp goto_cc_cmdline.cpp \
-      ms_cl_mode.cpp armcc_mode.cpp cw_mode.cpp
+      goto_cc_languages.cpp goto_cc_cmdline.cpp \
+      ms_cl_mode.cpp armcc_mode.cpp cw_mode.cpp ld_mode.cpp
 
-OBJ += ../big-int/bigint$(OBJEXT) \
+OBJ += ../big-int/big-int$(LIBEXT) \
       ../goto-programs/goto-programs$(LIBEXT) \
-      ../pointer-analysis/pointer-analysis$(LIBEXT) \
       ../util/util$(LIBEXT) \
       ../linking/linking$(LIBEXT) \
       ../ansi-c/ansi-c$(LIBEXT) \
       ../xmllang/xmllang$(LIBEXT) \
+      ../assembler/assembler$(LIBEXT) \
       ../langapi/langapi$(LIBEXT)
 
-INCLUDES= -I .. -I ../util
+INCLUDES= -I ..
 
 LIBS =

=== src/goto-instrument/Makefile ===
--- 
+++ 
@@ -1,21 +1,32 @@
-SRC = main.cpp parseoptions.cpp document_claims.cpp languages.cpp \
-      uninitialized.cpp uninitialized_domain.cpp full_slicer.cpp \
+SRC = goto_instrument_main.cpp goto_instrument_parseoptions.cpp \
+      document_properties.cpp goto_instrument_languages.cpp \
+      uninitialized.cpp full_slicer.cpp k_induction.cpp \
       object_id.cpp show_locations.cpp points_to.cpp \
       alignment_checks.cpp race_check.cpp rw_set.cpp \
-      weak_memory.cpp nondet_volatile.cpp interrupt.cpp \
+      nondet_volatile.cpp interrupt.cpp function.cpp branch.cpp \
       mmio.cpp stack_depth.cpp nondet_static.cpp \
-      cfg_dominators.cpp natural_loops.cpp
+      concurrency.cpp dump_c.cpp dot.cpp havoc_loops.cpp \
+      wmm/weak_memory.cpp wmm/fence.cpp wmm/event_graph.cpp \
+      wmm/goto2graph.cpp wmm/data_dp.cpp wmm/abstract_event.cpp \
+      wmm/instrumenter_strategies.cpp wmm/cycle_collection.cpp \
+      call_sequences.cpp unwind.cpp \
+      accelerate/accelerate.cpp accelerate/polynomial.cpp \
+      accelerate/scratch_program.cpp accelerate/polynomial_accelerator.cpp \
+      accelerate/util.cpp count_eloc.cpp reachability_slicer.cpp
 
 OBJ += ../ansi-c/ansi-c$(LIBEXT) \
       ../linking/linking$(LIBEXT) \
-      ../big-int/bigint$(OBJEXT) \
+      ../big-int/big-int$(LIBEXT) \
       ../goto-programs/goto-programs$(LIBEXT) \
       ../goto-symex/goto-symex$(LIBEXT) \
+      ../assembler/assembler$(LIBEXT) \
       ../pointer-analysis/pointer-analysis$(LIBEXT) \
+      ../analyses/analyses$(LIBEXT) \
       ../langapi/langapi$(LIBEXT) \
-      ../util/util$(LIBEXT)
+      ../util/util$(LIBEXT) \
+      ../solvers/solvers$(LIBEXT)
 
-INCLUDES= -I .. -I ../util
+INCLUDES= -I ..
 
 LIBS =
 
@@ -53,6 +64,6 @@
 
 .PHONY: goto-instrument-mac-signed
 
-goto-instrument-mac-signed: cbmc$(EXEEXT)
+goto-instrument-mac-signed: goto-instrument$(EXEEXT)
 	codesign -v -s $(OSX_IDENTITY) goto-instrument$(EXEEXT)

=== src/goto-programs/Makefile ===
SRC = goto_convert.cpp goto_convert_function_call.cpp \
      goto_convert_side_effect.cpp goto_program.cpp basic_blocks.cpp \
      goto_convert_exceptions.cpp \
      remove_function_pointers.cpp goto_functions.cpp goto_inline.cpp \
      remove_skip.cpp goto_convert_functions.cpp string_instrumentation.cpp \
      builtin_functions.cpp show_properties.cpp set_properties.cpp \
      read_goto_binary.cpp goto_asm.cpp elf_reader.cpp \
      string_abstraction.cpp destructor.cpp \
      goto_program_serialization.cpp goto_function_serialization.cpp \
      read_bin_goto_object.cpp goto_program_irep.cpp interpreter.cpp \
      interpreter_evaluate.cpp flow_insensitive_analysis.cpp \
      format_strings.cpp loop_ids.cpp pointer_arithmetic.cpp \
      goto_program_template.cpp write_goto_binary.cpp remove_unreachable.cpp \
      remove_unused_functions.cpp \
      wp.cpp goto_rw.cpp goto_clean_expr.cpp safety_checker.cpp \
      compute_called_functions.cpp link_to_library.cpp \
      remove_returns.cpp osx_fat_reader.cpp

INCLUDES= -I ..

include ../config.inc
include ../common

LIBS = ../ansi-c/ansi-c$(LIBEXT) \
       ../cpp/cpp$(LIBEXT) \
       ../linking/linking$(LIBEXT) \
       ../util/util$(LIBEXT) \
       ../big-int/big-int$(LIBEXT) \
       ../pointer-analysis/pointer-analysis$(LIBEXT) \
       ../langapi/langapi$(LIBEXT) \
       ../assembler/assembler$(LIBEXT) \
       ../analyses/analyses$(LIBEXT)

CLEANFILES = goto-programs$(LIBEXT) test_wp$(EXEEXT) osx_fat_reader_test$(EXEEXT)

all: goto-programs$(LIBEXT)

###############################################################################

goto-programs$(LIBEXT): $(OBJ)
	$(LINKLIB)

test_wp$(EXEEXT): test_wp$(OBJEXT) goto-programs$(LIBEXT)
	$(LINKBIN)

osx_fat_reader_test$(EXEEXT): osx_fat_reader_test$(OBJEXT) goto-programs$(LIBEXT)
	$(LINKBIN)

=== src/goto-symex/Makefile ===
SRC = symex_target.cpp symex_target_equation.cpp goto_symex.cpp \
      symex_main.cpp goto_trace.cpp build_goto_trace.cpp \
      symex_function_call.cpp goto_symex_state.cpp symex_dereference.cpp \
      symex_goto.cpp symex_builtin_functions.cpp slice.cpp symex_other.cpp \
      slice_by_trace.cpp xml_goto_trace.cpp symex_decl.cpp symex_dead.cpp \
      precondition.cpp postcondition.cpp symex_clean_expr.cpp \
      symex_dereference_state.cpp vcd_goto_trace.cpp auto_objects.cpp \
      symex_catch.cpp symex_start_thread.cpp symex_assign.cpp \
      symex_throw.cpp symex_atomic_section.cpp memory_model.cpp \
      memory_model_sc.cpp partial_order_concurrency.cpp \
      memory_model_tso.cpp memory_model_pso.cpp

INCLUDES= -I ..

include ../config.inc
include ../common

CLEANFILES = goto-symex$(LIBEXT)

all: goto-symex$(LIBEXT)

###############################################################################

goto-symex$(LIBEXT): $(OBJ)
	$(LINKLIB)

=== debian/changelog ===
cbmc (4.5-2ubuntu2) trusty; urgency=low

  * arm64-aarch64: Use __aarch64__ on arm64, not __arm64__ or __arm__

 -- Adam Conrad <adconrad@ubuntu.com>  Mon, 28 Oct 2013 12:45:20 -0600

cbmc (4.5-2ubuntu1) trusty; urgency=low

  * Merge from Debian unstable; remaining changes:
    - build with -Wno-error=unused-result to avoid FTBFS from -Werror

 -- Adam Conrad <adconrad@ubuntu.com>  Mon, 28 Oct 2013 10:47:38 -0600

cbmc (4.5-2) unstable; urgency=low

  * Fixed typo in powerpc sub-arch configuration causing FTBFS

 -- Michael Tautschnig <mt@debian.org>  Mon, 26 Aug 2013 00:07:54 +0100

cbmc (4.5-1) unstable; urgency=low

  * New upstream release
  * All 4.4 patches merged

 -- Michael Tautschnig <mt@debian.org>  Sun, 25 Aug 2013 12:33:14 +0100

cbmc (4.4-2) unstable; urgency=low

  * armhf requires __ARM_PCS_VFP to be defined

 -- Michael Tautschnig <mt@debian.org>  Wed, 10 Jul 2013 22:56:58 +0100

cbmc (4.4-1) unstable; urgency=low

  * New upstream release (Closes: #701253, #713605)

 -- Michael Tautschnig <mt@debian.org>  Wed, 10 Jul 2013 12:39:13 +0100

cbmc (4.3-6) unstable; urgency=low

  * Also added -5 patch to series  file to actually fix the problems
  * Update gcc_types_compatible_p1 to SVN HEAD
  * Cherry-pick upstream r2114-2118, r2120, r2167

 -- Michael Tautschnig <mt@debian.org>  Fri, 15 Feb 2013 18:35:06 +0000

cbmc (4.3-5) unstable; urgency=low

  * Cherry-pick upstream r2113 to fix failing regression tests on arm* and
    mips*
  * Cherry-pick upstream r2144 and r2148 to fix failing regression tests on
    powerpc, s390*, and sparc

 -- Michael Tautschnig <mt@debian.org>  Fri, 15 Feb 2013 10:52:56 +0000

cbmc (4.3-4) unstable; urgency=low

  * Cherry-pick upstream r2142 and r2143 to fix failing regression tests on
    arm*, mips*, powerpc, s390*, and sparc

 -- Michael Tautschnig <mt@debian.org>  Tue, 12 Feb 2013 15:01:56 +0000

cbmc (4.3-3) unstable; urgency=low

  * Cherry-pick upstream r2134 and r2139 to fix failing regression tests on
    arm*, ia64, mips*, powerpc, s390*, and sparc

 -- Michael Tautschnig <mt@debian.org>  Mon, 11 Feb 2013 21:12:02 +0000

cbmc (4.3-2) unstable; urgency=low

  * Cherry-pick upstream r2111 to fix build failure on ia64 and s390x 

 -- Michael Tautschnig <mt@debian.org>  Fri, 08 Feb 2013 15:46:35 +0000

cbmc (4.3-1) unstable; urgency=low

  * New upstream release (all code patches merged, only build system
    adaptions)

 -- Michael Tautschnig <mt@debian.org>  Fri, 08 Feb 2013 11:12:41 +0000

=== debian/rules ===
--- 
+++ 
@@ -9,10 +9,19 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-export DEB_CXXFLAGS_MAINT_APPEND := -Wall -O2 -g -Werror -Wno-long-long -Wno-sign-compare -Wno-parentheses -Wno-strict-aliasing -Wno-unused-result -pedantic
+export DEB_CXXFLAGS_MAINT_APPEND := -Wall -O2 -g -Werror -Wno-long-long -Wno-sign-compare -Wno-parentheses -Wno-strict-aliasing -Wno-error=unused-result -pedantic
 
 %:
 	dh $@ --parallel
+
+override_dh_auto_clean:
+	dh_auto_clean
+	$(MAKE) -C src clean
+	$(RM) regression/*/tests.log
+	$(RM) regression/*/*/*.out
+
+override_dh_auto_build:
+	$(MAKE) -C src MINISAT2=/usr/include/minisat
 
 override_dh_auto_test:
 	cd regression/ansi-c ; \
@@ -30,4 +39,9 @@
 		  ../../debian/failed-tests-printer.pl ; \
 			exit 1 ; \
 		fi
+	cd regression/cbmc-concurrency ; \
+		if ! ../test.pl -c ../../../src/cbmc/cbmc ; then \
+		  ../../debian/failed-tests-printer.pl ; \
+			exit 1 ; \
+		fi
